import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import ptolemy.plot.Plot;
/*
 * File: Gui.java
 * Date         Author          Changes
 * 28.01.2006   Mike Mller     Created
 *
 */

public class Gui extends JPanel implements ActionListener {

    private static final long serialVersionUID = 8155855277190736542L;

    // Der Plot fr die Grafik
    private static Plot grafik = new Plot();
    
    // Felder fr die Eingaben und Einstellmglichkeiten 
    private JTextField mutation, crossover, population, generation;
    private JTextField fitBestInd, fitWorseInd, fitMiddleInd;
    private JTextField ergXWertBest, ergXWertWorse;
    private JComboBox functionBox;
    private static JTextArea logausgabe;
    // Buttons
    private JButton step, all, init;
    // Population
    private Population_v2 pop;
    
    public Gui() {
        setLayout(null);
        
        grafik.setBounds(300,-10, 510, 300);
        grafik.setToolTipText("Anzeige der Funktion");
        paintGauss();
        add(grafik);
        
        JLabel headline = new JLabel("Einstellungen");
        headline.setFont(new Font("Arial", Font.BOLD, 16));
        headline.setBounds(10, 10, 110, 20);
        add(headline);
        
        JLabel labelFunction = new JLabel("Funktion:");
        labelFunction.setBounds(10, 40, 100, 20);
        add(labelFunction);
        Object[] functions = {"Gauss", "5 Maxima", "4 Maxima"};
        functionBox = new JComboBox(functions);
        functionBox.setToolTipText("Funktion auswhlen deren Maxima ausgerechnet werden soll.");
        functionBox.setBounds(110, 40, 100, 20);
        functionBox.setName("functionsChanged");
        functionBox.addActionListener(this);
        add(functionBox);
        
        JLabel labelPopulation = new JLabel("Population:");
        labelPopulation.setBounds(10, 65, 100, 20);
        add(labelPopulation);
        population = new JTextField();
        population.setText("10");
        population.setToolTipText("Die Anzahl der Individuen angeben.");
        population.setBounds(110, 65, 100, 20);
        add(population);
        
        JLabel labelGeneration = new JLabel("Generationen:");
        labelGeneration.setBounds(10, 90, 100, 20);
        add(labelGeneration);
        generation = new JTextField();
        generation.setText("50");
        generation.setToolTipText("ber wieviele Generatoinen soll gerechnet werden?");
        generation.setBounds(110, 90, 100, 20);
        add(generation);
        
        JLabel labelMutation = new JLabel("Mutation (0 - 1):");
        labelMutation.setBounds(10, 115, 100, 20);
        add(labelMutation);
        mutation = new JTextField();
        mutation.setText("0.1");
        mutation.setToolTipText("Den Mutationsfaktor zwischen 0 und 1 angeben.");
        mutation.setBounds(110, 115, 100, 20);
        add(mutation);
        
        JLabel labelCrossover = new JLabel("Crossover (0 - 1):");
        labelCrossover.setBounds(10, 140, 100, 20);
        add(labelCrossover);
        crossover = new JTextField();
        crossover.setText("0.8");
        crossover.setToolTipText("Den Kreuzungsfaktor zwischen 0 und 1 angeben.");
        crossover.setBounds(110, 140, 100, 20);
        add(crossover);
        
        
        /////// ERGEBNIS /////////
        
        JLabel headline2 = new JLabel("Ergebnis");
        headline2.setFont(new Font("Arial", Font.BOLD, 16));
        headline2.setBounds(10, 180, 100, 20);
        add(headline2);
        
        JLabel labelFitBestInd = new JLabel("Fitness des besten Individums");
        labelFitBestInd.setBounds(10, 200, 200, 20);
        add(labelFitBestInd);
        fitBestInd = new JTextField();
        fitBestInd.setToolTipText("Die Fitness des besten Individums.");
        fitBestInd.setEditable(false);
        fitBestInd.setBounds(10, 225, 200, 20);
        add(fitBestInd);
        
        JLabel labelFitWorseInd = new JLabel("Fitness des schlechtesten Individums");
        labelFitWorseInd.setBounds(10, 250, 220, 20);
        add(labelFitWorseInd);
        fitWorseInd = new JTextField();
        fitWorseInd.setToolTipText("Die Fitness des schlechtesten Individums.");
        fitWorseInd.setEditable(false);
        fitWorseInd.setBounds(10, 275, 200, 20);
        add(fitWorseInd);
        
        JLabel labelFitMiddleInd = new JLabel("Durchschnittliche Fitness");
        labelFitMiddleInd.setBounds(10, 300, 200, 20);
        add(labelFitMiddleInd);
        fitMiddleInd = new JTextField();
        fitMiddleInd.setToolTipText("Der durchschnittliche Fitness Wert.");
        fitMiddleInd.setEditable(false);
        fitMiddleInd.setBounds(10, 325, 200, 20);
        add(fitMiddleInd);
        
        JLabel labelErgXWert = new JLabel("X - Wert");
        labelErgXWert.setBounds(230, 200, 100, 20);
        add(labelErgXWert);
        ergXWertBest = new JTextField();
        ergXWertBest.setToolTipText("Postion auf der X-Achse des besten Individums.");
        ergXWertBest.setEditable(false);
        ergXWertBest.setBounds(230, 225, 50, 20);
        add(ergXWertBest);
        
        JLabel labelErgXWertWorse = new JLabel("X - Wert");
        labelErgXWertWorse.setBounds(230, 250, 100, 20);
        add(labelErgXWertWorse);
        ergXWertWorse = new JTextField();
        ergXWertWorse.setToolTipText("Poistion auf der X-Achse des schlechtesten Individums.");
        ergXWertWorse.setEditable(false);
        ergXWertWorse.setBounds(230, 275, 50, 20);
        add(ergXWertWorse);
        
        
        /////// BUTTONS /////////
        step = new JButton("STEP");
        step.addActionListener(this);
        step.setToolTipText("Eine Generation weiter berechnen.");
        step.setBounds(10, 410, 150, 25);
        add(step);
        
        all = new JButton("START");
        all.addActionListener(this);
        all.setToolTipText("Alles berechnen.");
        all.setBounds(10, 380, 150, 25);
        add(all);
        
        init = new JButton("INIT");
        init.addActionListener(this);
        init.setToolTipText("Initialisiert die Population");
        init.setBounds(10, 350, 150, 25);
        add(init);
        
        
        /////// LOG AUSGABE ///////
        logausgabe = new JTextArea(1,1);
        logausgabe.setEditable(false);
        logausgabe.setWrapStyleWord(true);
        logausgabe.setLineWrap(true);
        JScrollPane s = new JScrollPane(logausgabe);
        s.setBounds(335, 300, 445, 140);
        add(s);
    }
    
    /**
     * Kann man Text in die Log Ausgabe einfgen
     * @param text Text zum einfgen
     */
    public static final void addLogAusgabe(Object text) {
        logausgabe.append(text.toString()+"\n");        
    }
    
    
    /**
     * @return Returns the crossover.
     */
    private final double getCrossover() {
        return Double.parseDouble(crossover.getText());
    }

    /**
     * @return Returns the generation.
     */
    private final int getGeneration() {
        return Integer.parseInt(generation.getText());
    }

    /**
     * @return Returns the mutation.
     */
    private final double getMutation() {
        return Double.parseDouble(mutation.getText());
    }

    /**
     * @return Returns the population.
     */
    private final int getPopulation() {
        return Integer.parseInt(population.getText());
    }

    /**
     * @param fitBestInd The fitBestInd to set.
     */
    private final void setFitBestInd(double fitBestInd) {
        DecimalFormat df = new DecimalFormat("0.00000000");
        this.fitBestInd.setText(""+df.format(fitBestInd));
    }

    /**
     * @param fitMiddleInd The fitMiddleInd to set.
     */
    private final void setFitMiddleInd(double fitMiddleInd) {
        DecimalFormat df = new DecimalFormat("0.00000000");
        this.fitMiddleInd.setText(""+df.format(fitMiddleInd));
    }

    /**
     * @param fitWorseInd The fitWorseInd to set.
     */
    private final void setFitWorseInd(double fitWorseInd) {
        DecimalFormat df = new DecimalFormat("0.00000000");
        this.fitWorseInd.setText(""+df.format(fitWorseInd));
    }
    
    private final void setBestX(double xpos) {
        DecimalFormat df = new DecimalFormat("0.00");
        this.ergXWertBest.setText(""+df.format(xpos));
    }
    
    private final void setWorseX(double xpos) {
        DecimalFormat df = new DecimalFormat("0.00");
        this.ergXWertWorse.setText(""+df.format(xpos));
    }

    private void paintGauss() {
        double x2 =0;
        double sigma=0.1, my=0.5;
        for (int x = 00; x <= 400; x++) {
            x2 += 0.0025;
            double y = (1 / (sigma * Math.sqrt(2 * Math.PI))) * Math.exp(-0.5 * Math.pow(((x2-my)/sigma),2));
            grafik.addPoint(0, x2, y, true);
        }
        this.repaint();
    }
    
    private void paintFunction2() {
        double x2 =0;
        for (int x = 0; x <= 400; x++) {
            x2 += 0.0025;
            double y = Math.pow(Math.sin(5*Math.PI*x2), 6);
            
            grafik.addPoint(0, x2, y, true);
        }
        this.repaint();
    }
    
    private void paintFunction3() {
        double x2 =0;
        for (int x = 0; x <= 400; x++) {
            x2 += 0.0025;
            double y = Math.pow(Math.sin(5*Math.PI*x2)* Math.exp(-2* Math.log(2) * Math.pow((x2-0.1)/0.8, 2) ), 6);
            
            grafik.addPoint(0, x2, y, true);
        }
        this.repaint();
    }
    
    /**
     * Zeichnet die Postionen der Individuen auf dem Plot.
     * @param xpos Position auf der X-Achse
     * @param ypos Position auf der Y-Achse
     */
    public static void paintIndividum(double xpos, double ypos) {
        grafik.addPointWithErrorBars(1, xpos, 0, ypos - 0.05, ypos + 0.05, false);
    }

    /**
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent event) {
        String cmd = event.getActionCommand();
        
        if (cmd.equals("comboBoxChanged")) {
            // Gauss
            if (functionBox.getSelectedIndex() == 0) {
                grafik.clear(true);
                paintGauss();
            }
            if (functionBox.getSelectedIndex() == 1) {
                grafik.clear(true);
                paintFunction2();
            }
            if (functionBox.getSelectedIndex() == 2) {
                grafik.clear(true);
                paintFunction3();
            }
        }
        // Schritt Button
        if (cmd.equals(step.getText())) {
            Gui.addLogAusgabe("Nchste Generation wird berechnet");
            grafik.clear(1);
            pop.step();
            this.setFitBestInd(pop.GetBestIndividium());
            this.setFitMiddleInd(pop.GetMedian());
            this.setFitWorseInd(pop.GetWorseIndividium());
            this.setBestX(pop.GetBestIndividiumX());
            this.setWorseX(pop.GetWorseIndividiumX());
            pop.ShowPopulation();
        }
        // Start Button
        if (cmd.equals(all.getText())) {
            Gui.addLogAusgabe("Starte Berechnung");
            grafik.clear(1);
            pop.start();
            this.setFitBestInd(pop.GetBestIndividium());
            this.setFitMiddleInd(pop.GetMedian());
            this.setFitWorseInd(pop.GetWorseIndividium());
            this.setBestX(pop.GetBestIndividiumX());
            this.setWorseX(pop.GetWorseIndividiumX());
            pop.ShowPopulation();
        }
        // Init Button
        if (cmd.equals(init.getText())) {
            grafik.clear(1);
            Gui.addLogAusgabe("Initialisiere neue Population");
            pop = new Population_v2(getPopulation(), getGeneration(), getMutation(), getCrossover(), functionBox.getSelectedIndex());
            this.setFitBestInd(pop.GetBestIndividium());
            this.setFitMiddleInd(pop.GetMedian());
            this.setFitWorseInd(pop.GetWorseIndividium());
            this.setBestX(pop.GetBestIndividiumX());
            this.setWorseX(pop.GetWorseIndividiumX());
            pop.ShowPopulation();
        }
    }

}
