

import java.awt.event.ActionListener;

import javax.swing.JCheckBoxMenuItem;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

/**
 * Diese Klasse erzeugt die Menleiste.
 * @author Mike Mller
 */
public class MyMenueBar extends JMenuBar {

    private static final long serialVersionUID = -4994561169512634729L;
    /**
     * Der ActionListener
     */
    private ActionListener listener;

    /**
     * Der Konstuktor der alle Meneintrage erstellt.
     * @param listener Der Actionlistener
     */
    public MyMenueBar(final ActionListener listener) {
        this.listener = listener;
        JMenu m;

        //Men Datei
        m = new JMenu("Datei");
        addItem(m, "Beenden", "menueende", "normal");
        add(m);

        //Men Hilfe
        m = new JMenu("Hilfe");
        addItem(m, "ber Genetische Algorithmen", "about", "normal");
        add(m);
    }

    /**
     * Fgt ein Element in die dementsprechende Stelle hinzu.
     * @param m Das Menobjekt
     * @param name Der sichtbare Name des Eintrags
     * @param cmd Der Kommandoname des Eintrags
     * @param type Typ des Buttons (<code>checkbox</code>, <code>normal</code>)
     */
    private void addItem(final JMenu m, final String name, final String cmd, final String type) {
        if (type.equals("normal")) {
            JMenuItem mi = new JMenuItem(name);
            mi.setActionCommand(cmd);
            mi.addActionListener(listener);
            m.add(mi);
        }
        if (type.equals("checkbox")) {
            JCheckBoxMenuItem mi = new JCheckBoxMenuItem(name);
            mi.setSelected(true);
            mi.setActionCommand(cmd);
            mi.addActionListener(listener);
            m.add(mi);
        }
    }
}