
public class Population_v2 {
	
	class BitData {
		private double fitValue;
        private double xpos = 0;
		
		public BitData () {
            xpos = (Math.random());
		}
		
		public BitData (double x) {
			this.xpos = x;
			this.fitValue = CalculateFitness();
		}
		
		public void SetData (BitData bitData) {
			this.fitValue = bitData.fitValue;
            this.xpos = bitData.xpos;
		}
		
		public double CalculateFitness () {
			fitValue = 0;

            // Fitness = der y Wert der jeweiligen Funktion
            if (function == 0) {
                fitValue = paintGauss(xpos);
            }
            if (function == 1) {
                fitValue = paintFunction2(xpos);
            }
            if (function == 2) {
                fitValue = paintFunction3(xpos);
            }
						
			return fitValue;
		}
		
        private double paintGauss(double x) {
            double sigma=0.1, my=0.5;

            double y = (1 / (sigma * Math.sqrt(2 * Math.PI))) * Math.exp(-0.5 * Math.pow(((x-my)/sigma),2));

            return y;
        }
        
        private double paintFunction2(double x) {
            
            double y = Math.pow(Math.sin(5*Math.PI*x), 6);
                
            return y;
        }
        
        private double paintFunction3(double x) {

           double y = Math.pow(Math.sin(5*Math.PI*x)* Math.exp(-2* Math.log(2) * Math.pow((x-0.1)/0.8, 2) ), 6);
                
           return y;
        }
        
		@Override
        public String toString () {
			return Double.toString(xpos);
		}
	}
	
	// Immer ein Vielfaches von 2 fr die Elementanzahl benutzen
	private int ELEMENTS = 7;
	private BitData myElements[];// = new BitData[ELEMENTS];
	private int i;
	private double median;
    
    // eingaben aus der GUI
    private int generation;
    private double mutation;
    private double crossover;
    private int function;
    private int stepMake = 0;
		
	public Population_v2 () {
        myElements = new BitData[ELEMENTS];
		// Create new Elements
		for (i=0; i<ELEMENTS; i++) {
			myElements[i] = new BitData();
		}
	}
    
    public Population_v2 (int population, int generation, double mutation, double crossover, int function) {
        ELEMENTS = population;
        this.generation = generation;
        this.crossover = crossover;
        this.mutation = mutation;
        this.function = function;
        
        myElements = new BitData[ELEMENTS];
        // Create new Elements
        for (i=0; i<ELEMENTS; i++) {
            myElements[i] = new BitData();
            Gui.paintIndividum(myElements[i].xpos, myElements[i].CalculateFitness());
        }
    }
	
	public void ShowPopulation () {
		for (i=0; i<ELEMENTS; i++) {
            Gui.paintIndividum(myElements[i].xpos, myElements[i].CalculateFitness());
            Gui.addLogAusgabe("Bitset "+(i+1)+" ist gleich: " + myElements[i].toString()+" mit dem Fitnesswert = "+ myElements[i].CalculateFitness());
		}
	}
	
	public void Selection () {
		// Fitnesswert neu berechnen
		for (int i=0; i<ELEMENTS; i++)
			myElements[i].CalculateFitness();

		// Population sortieren, anhand Fitnesswert
		this.MergeSortDivide(0, ELEMENTS-1);
	}
	
	public void CrossOver () {
		int nCount = 0;
        BitData myParents[] = new BitData[ELEMENTS];
		this.Selection();
		
		median = GetMedian();

		// Anzahl der zu lschenden Individien berechnen,
		// sowie den index des letzten Elements, welches
		// kleiner wie der Median ist.
        // Es werden auch die Individuen ausgewhlt die Paarungsfhig sind.
		for (int i=ELEMENTS-1, j=0; i>=0; i--) {
			if (myElements[i].fitValue < median) {
				nCount++;
			} else {
			    myParents[j] = myElements[i];
                j++;
            }
		}
        
        // Der beste ist immer in der nchsten Generation dabei
        myElements[0] = myParents[0];
        
        // Jetzt drfen sich ein paar Individuen paaren und der Rest wird durch neue aufgefllt.
        // Die Stelle der Trennung wird zufllig durch den Faktor crossover entschieden
        for (int i=1; i<(ELEMENTS-nCount); i+=2) {
            // Test ob noch einer da ist :-)
            if (i+1 <(ELEMENTS-nCount)) {
                int stelle = (int) (Math.random()*62);

                // soll getauscht werden oder werden sie in die nchste Generation aufgenommen
                if (Math.random() < crossover && stelle != 0) {
                    String vater = Long.toBinaryString(Double.doubleToLongBits(myParents[i].xpos));
                    String mutter = Long.toBinaryString(Double.doubleToLongBits(myParents[i+1].xpos));
                    
                    String vaterTeil = vater.substring(stelle);
                    String mutterTeil = mutter.substring(stelle);
                    
                    double vaterZahl = Double.longBitsToDouble(Long.parseLong(vater.substring(0, stelle).concat(mutterTeil), 2));
                    double mutterZahl = Double.longBitsToDouble(Long.parseLong(mutter.substring(0, stelle).concat(vaterTeil), 2));
                    
                    // Test ob Wertebereich berschritten wurde.
                    if (vaterZahl > 1)
                        vaterZahl = vaterZahl - 1;
                    if (mutterZahl > 1)
                        mutterZahl = mutterZahl - 1;
                    
                    myElements[i] = new BitData(vaterZahl);
                    myElements[i+1] = new BitData(mutterZahl);
                    //Double.longBitsToDouble(Long.parseLong(vater.substring(0, stelle-1).concat(mutterTeil), 2));
                } else {
                    myElements[i] = myParents[i];
                    myElements[i+1] = myParents[i+1];
                }
            }
        }
        
		// Neue Individien erzeugen
		for (int i=(ELEMENTS-nCount); i<ELEMENTS; i++) {
			myElements[i] = new BitData();
		}
	}
	
	public void Mutation () {
        
        for (int i=0; i <ELEMENTS; i++) {
            if (Math.random() < mutation) {
                String mutant = Long.toBinaryString(Double.doubleToLongBits(myElements[i].xpos));
                char mutantTmp[] = mutant.toCharArray();
                int stelle = (int) (Math.random()*62);
                if (mutant.charAt(stelle) == '0')
                    mutantTmp[stelle] = '1';
                else
                    mutantTmp[stelle] = '0';
                
                String s = new String();
                for (int j=0; j<mutantTmp.length; j++) {
                    s = s + mutantTmp[j];
                }

                double x_wert = Double.longBitsToDouble(Long.parseLong(s, 2));
                
                // Falls der x_wert den Wertebereich berschreitet wird er angepasst.
                while (x_wert > 1) {
                    x_wert = x_wert -1;
                }
                Gui.addLogAusgabe("Mutation von "+myElements[i].xpos+" zu "+x_wert);
                myElements[i] = new BitData(x_wert);
            }
        }
		
	}

	public double GetBestIndividium () {
		double tmp = 0.0;
				
		for (int i=0; i<ELEMENTS; i++) {
			if (myElements[i].CalculateFitness() > tmp)
				tmp = myElements[i].fitValue;
		}
		return tmp;
	}
	
    public double GetWorseIndividium () {
        double tmp = myElements[0].CalculateFitness();
                
        for (int i=1; i<ELEMENTS; i++) {
            if (myElements[i].CalculateFitness() < tmp)
                tmp = myElements[i].fitValue;
        }
        return tmp;
    }
    
	public double GetMedian () {
		// Fitnesswert neu berechnen
		for (int i=0; i<ELEMENTS; i++)
			myElements[i].CalculateFitness();

		// Population sortieren
		this.MergeSortDivide(0, ELEMENTS-1);
		
		if (ELEMENTS % 2 == 0) 
			// Median berechnen
			median = 0.5 * (myElements[ELEMENTS/2-1].fitValue + myElements[ELEMENTS/2].fitValue);
		else
			median = myElements[ELEMENTS/2].fitValue;
		
		return median;
	}
    
    public double GetBestIndividiumX() {
        double tmp = 0.0;
        int index =0;
                
        for (int i=0; i<ELEMENTS; i++) {
            if (myElements[i].CalculateFitness() > tmp) {
                tmp = myElements[i].fitValue;
                index = i;
            }
        }
        return myElements[index].xpos;
    }
    
    public double GetWorseIndividiumX() {
        double tmp = myElements[0].CalculateFitness();
        int index = 0;
                
        for (int i=1; i<ELEMENTS; i++) {
            if (myElements[i].CalculateFitness() < tmp) {
                tmp = myElements[i].fitValue;
                index = i;
            }
        }
        return myElements[index].xpos;
    }
    
    public void step() {
        this.CrossOver();
        this.Mutation();
        stepMake++;
    }
    
    public void start() {
        for (int i=stepMake; i < generation; i++) {
            this.CrossOver();
            this.Mutation();
        }
    }
	
	private void MergeSortDivide(int loBo, int hiBo) {
		if (loBo < hiBo) {
			int middle = (loBo+hiBo)/2;
				
		    this.MergeSortDivide(loBo, middle);
		    this.MergeSortDivide(middle+1, hiBo);          
		    this.MergeSort(loBo, middle, hiBo);
		}
	}
	
	private void MergeSort(int p, int q, int r) {
		int lengthLeftArray = q-p+1;
		int lengthRightArray = r-q;
		int i, j;
		  
		BitData arrayLeft[]  = new BitData[lengthLeftArray];
		BitData arrayRight[] = new BitData[lengthRightArray];
		  
		for (i=0; i<lengthLeftArray; i++) {
			// Elemente dem linken Hilfsarray hinzufgen
			arrayLeft[i] = new BitData();
			arrayLeft[i].SetData(myElements[p+i]);
		}
		      
		for (j=0, i=q+1; j<lengthRightArray; j++) {
			// Elemente dem rechten Hilfsarray hinzufgen
			arrayRight[j] = new BitData();
			arrayRight[j].SetData(myElements[i]);
		    i++;
		}
		    
		i=0;
		j=0;
				
		for (int k=p; k<=r; k++) {
		    // Abfragen ob das Array noch gengend Felder hat.
		    if (i < lengthLeftArray && j < lengthRightArray) {
		      if (arrayLeft[i].fitValue >= arrayRight[j].fitValue) {
		    	  this.myElements[k].SetData(arrayLeft[i]);
		    	  i++;
		      }
		      else {
		    	  this.myElements[k].SetData(arrayRight[j]);
		    	  j++;
		      }
		    } 
		    else {
		      if (i < lengthLeftArray) {
		    	  this.myElements[k].SetData(arrayLeft[i]);
		    	  i++;
		      }
		      else if (j < lengthRightArray) {
		    	  this.myElements[k].SetData(arrayRight[j]);
		    	  j++;
		      }
		    }
		}
	}
}
